"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getShareableDTO = exports.setShareable = void 0;
exports.ShareableDTO = ShareableDTO;
const nestjs_query_core_1 = require("@rezonate/nestjs-query-core");
const graphql_1 = require("@nestjs/graphql");
const constants_1 = require("./constants");
const reflector = new nestjs_query_core_1.ValueReflector(constants_1.SHAREABLE_KEY);
function ShareableDTO() {
    return (DTOClass) => reflector.set(DTOClass, true);
}
const setShareable = (DTOClass) => (0, graphql_1.Directive)('@shareable')(DTOClass);
exports.setShareable = setShareable;
const getShareableDTO = (DTOClass) => reflector.get(DTOClass, true);
exports.getShareableDTO = getShareableDTO;
//# sourceMappingURL=shareable.dto.decorator.js.map