import { AggregateQuery, AggregateResponse, Class, Filter, QueryService } from '@rezonate/nestjs-query-core';
import { NestjsQueryDataloader } from './relations.loader';
type AggregateRelationsArgs<DTO, Relation> = {
    dto: DTO;
    filter: Filter<Relation>;
    aggregate: AggregateQuery<Relation>;
};
export declare class AggregateRelationsLoader<DTO, Relation> implements NestjsQueryDataloader<DTO, AggregateRelationsArgs<DTO, Relation>, (AggregateResponse<Relation> | Error)[]> {
    readonly RelationDTO: Class<Relation>;
    readonly relationName: string;
    constructor(RelationDTO: Class<Relation>, relationName: string);
    createLoader(service: QueryService<DTO>, groupByLimit?: number, maxRowsAggregationLimit?: number, maxRowsAggregationWithIndexLimit?: number, limitAggregateByTableSize?: boolean): (queryArgs: ReadonlyArray<AggregateRelationsArgs<DTO, Relation>>) => Promise<(AggregateResponse<Relation> | Error)[][]>;
    private loadResults;
    private groupQueries;
}
export {};
