import { DynamicModule, ForwardReference, Provider } from '@nestjs/common';
import { Class } from '@rezonate/nestjs-query-core';
import { AutoResolverOpts } from './providers';
import { ReadResolverOpts } from './resolvers';
import { GraphQLPubSub } from './subscription';
import { PagingStrategies } from './types/query/paging';
interface DTOModuleOpts<DTO> {
    DTOClass: Class<DTO>;
}
export interface NestjsQueryGraphqlModuleOpts {
    imports: Array<Class<any> | DynamicModule | Promise<DynamicModule> | ForwardReference>;
    services?: Provider[];
    resolvers?: AutoResolverOpts<any, any, ReadResolverOpts<any>, PagingStrategies>[];
    dtos?: DTOModuleOpts<unknown>[];
    pubSub?: Provider<GraphQLPubSub>;
}
export declare class NestjsQueryGraphQLModule {
    static forFeature(opts: NestjsQueryGraphqlModuleOpts): DynamicModule;
    static defaultPubSubProvider(): Provider<GraphQLPubSub>;
    private static getProviders;
    private static getScalarsProviders;
    private static getPubSubProviders;
    private static getServicesProviders;
    private static getResolverProviders;
    private static getAuthorizerProviders;
    private static getHookProviders;
}
export {};
