import { Provider } from '@nestjs/common';
import { Class } from '@rezonate/nestjs-query-core';
import { CRUDResolverOpts } from '../resolvers';
import { PagingStrategies } from '../types/query/paging';
export type CRUDAutoResolverOpts<DTO, R, PS extends PagingStrategies> = CRUDResolverOpts<DTO, R, PS> & {
    DTOClass: Class<DTO>;
};
export type EntityCRUDAutoResolverOpts<DTO, Entity, R, PS extends PagingStrategies> = CRUDAutoResolverOpts<DTO, R, PS> & {
    EntityClass: Class<Entity>;
};
export type ServiceCRUDAutoResolverOpts<DTO, QueryService, R, PS extends PagingStrategies> = CRUDAutoResolverOpts<DTO, R, PS> & {
    ServiceClass: Class<QueryService>;
};
export type FederatedAutoResolverOpts<DTO, Service> = {
    type: 'federated';
    DTOClass: Class<DTO>;
    Service: Class<Service>;
};
export type AutoResolverOpts<DTO, EntityService, R, PS extends PagingStrategies> = EntityCRUDAutoResolverOpts<DTO, EntityService, R, PS> | ServiceCRUDAutoResolverOpts<DTO, EntityService, R, PS> | FederatedAutoResolverOpts<DTO, EntityService>;
export declare const isFederatedResolverOpts: <DTO, MaybeService, R, PS extends PagingStrategies>(opts: AutoResolverOpts<DTO, MaybeService, R, PS>) => opts is FederatedAutoResolverOpts<DTO, MaybeService>;
export declare const isServiceCRUDAutoResolverOpts: <DTO, MaybeService, R, PS extends PagingStrategies>(opts: AutoResolverOpts<DTO, MaybeService, R, PS>) => opts is ServiceCRUDAutoResolverOpts<DTO, MaybeService, R, PS>;
export declare const createResolvers: (opts: AutoResolverOpts<object, object, unknown, PagingStrategies>[]) => Provider[];
