import { AggregateQuery, AggregateResponse, Class, Filter, QueryService } from '@rezonate/nestjs-query-core';
import { ResolverClass, ServiceResolver } from './resolver.interface';
import { AggregateByTimeArgsType } from '../types/aggregate/aggregate-by-time-args.type';
import { AggregateResolverOpts } from './aggregate.resolver';
export interface AggregateByTimeResolver<DTO, QS extends QueryService<DTO>> extends ServiceResolver<DTO, QS> {
    aggregateByTime(filter: AggregateByTimeArgsType<DTO>, aggregateQuery: AggregateQuery<DTO>, authFilter?: Filter<DTO>): Promise<AggregateResponse<DTO>[]>;
}
/**
 * @internal
 * Mixin to add `aggregate` graphql endpoints.
 */
export declare const AggregateableByTime: <DTO, QS extends QueryService<DTO>>(DTOClass: Class<DTO>, opts?: AggregateResolverOpts) => <B extends Class<ServiceResolver<DTO, QS>>>(BaseClass: B) => Class<AggregateByTimeResolver<DTO, QS>> & B;
export declare const AggregateByTimeResolver: <DTO, QS extends QueryService<DTO> = QueryService<DTO>>(DTOClass: Class<DTO>, opts?: AggregateResolverOpts) => ResolverClass<DTO, QS, AggregateByTimeResolver<DTO, QS>>;
