"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AggregateByTimeResolver = exports.AggregateableByTime = void 0;
const tslib_1 = require("tslib");
// eslint-disable-next-line max-classes-per-file
const graphql_1 = require("@nestjs/graphql");
const nestjs_query_core_1 = require("@rezonate/nestjs-query-core");
const lodash_omit_1 = tslib_1.__importDefault(require("lodash.omit"));
const auth_1 = require("../auth");
const common_1 = require("../common");
const decorators_1 = require("../decorators");
const interceptors_1 = require("../interceptors");
const helpers_1 = require("./helpers");
const resolver_interface_1 = require("./resolver.interface");
const aggregate_by_time_response_type_1 = require("../types/aggregate/aggregate-by-time-response.type");
const aggregate_by_time_args_type_1 = require("../types/aggregate/aggregate-by-time-args.type");
const aggregate_by_time_query_param_decorator_1 = require("../decorators/aggregate-by-time-query-param.decorator");
/**
 * @internal
 * Mixin to add `aggregate` graphql endpoints.
 */
const AggregateableByTime = (DTOClass, opts) => (BaseClass) => {
    if (!opts || !opts.enabled) {
        return BaseClass;
    }
    const { baseNameLower } = (0, common_1.getDTONames)(DTOClass);
    const commonResolverOpts = (0, lodash_omit_1.default)(opts, 'dtoName', 'one', 'many', 'QueryArgs', 'Connection');
    const queryName = `${baseNameLower}AggregateByTime`;
    const AR = (0, aggregate_by_time_response_type_1.AggregateByTimeResponseType)(DTOClass);
    let AA = class AA extends (0, aggregate_by_time_args_type_1.AggregateByTimeArgsType)(DTOClass) {
    };
    AA = tslib_1.__decorate([
        (0, graphql_1.ArgsType)()
    ], AA);
    let AggregateByTimeResolverBase = class AggregateByTimeResolverBase extends BaseClass {
        async aggregateByTime(args, query, authFilter) {
            const qa = await (0, helpers_1.transformAndValidate)(AA, args);
            const filter = (0, nestjs_query_core_1.mergeFilter)(qa.filter || {}, authFilter ?? {});
            return this.service.aggregateByTime(filter, query, args.field, args.from, args.to ?? new Date(), args.interval.count, args.interval.span, args.accumulate, qa.groupByLimit, opts.maxRowsForAggregate, opts.maxRowsForAggregateWithIndex, opts.limitAggregateByTableSize);
        }
    };
    tslib_1.__decorate([
        (0, decorators_1.ResolverQuery)(() => [AR], { name: queryName }, commonResolverOpts, { interceptors: [(0, interceptors_1.AuthorizerInterceptor)(DTOClass)] }, opts ?? {}),
        tslib_1.__param(0, (0, graphql_1.Args)({ type: () => AA })),
        tslib_1.__param(1, (0, aggregate_by_time_query_param_decorator_1.AggregateByTimeQueryParam)()),
        tslib_1.__param(2, (0, decorators_1.AuthorizerFilter)({
            operationGroup: auth_1.OperationGroup.AGGREGATE,
            many: true,
        })),
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [AA, Object, Object]),
        tslib_1.__metadata("design:returntype", Promise)
    ], AggregateByTimeResolverBase.prototype, "aggregateByTime", null);
    AggregateByTimeResolverBase = tslib_1.__decorate([
        (0, graphql_1.Resolver)(() => AR, { isAbstract: true })
    ], AggregateByTimeResolverBase);
    return AggregateByTimeResolverBase;
};
exports.AggregateableByTime = AggregateableByTime;
// eslint-disable-next-line @typescript-eslint/no-redeclare -- intentional
const AggregateByTimeResolver = (DTOClass, opts) => (0, exports.AggregateableByTime)(DTOClass, opts)(resolver_interface_1.BaseServiceResolver);
exports.AggregateByTimeResolver = AggregateByTimeResolver;
//# sourceMappingURL=aggregate.by.time.resolver.js.map