import { Class, QueryService } from '@rezonate/nestjs-query-core';
import { RepresentationType } from '../federation';
import { ResolverClass, ServiceResolver } from './resolver.interface';
export interface ReferenceResolverOpts {
    key?: string;
}
export interface ReferenceResolverType<DTO, QS extends QueryService<DTO> = QueryService<DTO>> extends ResolverClass<DTO, QS, ServiceResolver<DTO, QS>> {
    resolveReference(representation: RepresentationType): Promise<DTO>;
}
/**
 * @internal
 * Mixin to expose `resolveReference` for a DTO on the resolver.
 */
export declare const Referenceable: <DTO, QS extends QueryService<DTO>>(DTOClass: Class<DTO>, opts: ReferenceResolverOpts) => <B extends Class<ServiceResolver<DTO, QS>>>(BaseClass: B) => B & Class<ReferenceResolverType<DTO, QS>>;
export declare const ReferenceResolver: <DTO, QS extends QueryService<DTO> = QueryService<DTO>>(DTOClass: Class<DTO>, opts?: ReferenceResolverOpts) => Class<ReferenceResolverType<DTO, QS>>;
