import { Class, Filter } from '@rezonate/nestjs-query-core';
import { AggregateByTimeInterval } from './aggregate-by-time.interval';
export interface AggregateByTimeArgsType<DTO> {
    filter?: Filter<DTO>;
    groupByLimit?: number;
    field: string;
    from: Date;
    to?: Date;
    accumulate?: boolean;
    interval: AggregateByTimeInterval;
}
/**
 * The args type for aggregate queries
 * @param DTOClass - The class the aggregate is for. This will be used to create FilterType.
 */
export declare function AggregateByTimeArgsType<DTO>(DTOClass: Class<DTO>): Class<AggregateByTimeArgsType<DTO>>;
