"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AggregateByTimeArgsType = AggregateByTimeArgsType;
const tslib_1 = require("tslib");
const graphql_1 = require("@nestjs/graphql");
const nestjs_query_core_1 = require("@rezonate/nestjs-query-core");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const common_1 = require("../../common");
const decorators_1 = require("../../decorators");
const query_1 = require("../query");
const aggregate_by_time_interval_1 = require("./aggregate-by-time.interval");
(0, graphql_1.registerEnumType)(nestjs_query_core_1.AggregateByTimeIntervalSpan, { name: 'AggregateByTimeIntervalSpan' });
const defaultAggregateByTimeInterval = new aggregate_by_time_interval_1.AggregateByTimeInterval();
defaultAggregateByTimeInterval.count = 1;
defaultAggregateByTimeInterval.span = nestjs_query_core_1.AggregateByTimeIntervalSpan.day;
var InvalidFields;
(function (InvalidFields) {
    InvalidFields["InvalidFields"] = "InvalidFields";
})(InvalidFields || (InvalidFields = {}));
(0, graphql_1.registerEnumType)(InvalidFields, { name: 'InvalidFields' });
/**
 * The args type for aggregate queries
 * @param DTOClass - The class the aggregate is for. This will be used to create FilterType.
 */
// eslint-disable-next-line @typescript-eslint/no-redeclare -- intentional
function AggregateByTimeArgsType(DTOClass) {
    const prefix = (0, common_1.getGraphqlObjectName)(DTOClass, 'Unable to make AggregateByTimeArgs.');
    const F = (0, query_1.AggregateFilterType)(DTOClass);
    const fields = (0, decorators_1.getFilterableFields)(DTOClass);
    const dateFieldNames = fields.filter((f) => f.returnTypeFunc?.() === Date).map((field) => field.propertyName);
    const fieldNameMap = {
        ...dateFieldNames.reduce((acc, field) => ({ ...acc, [field]: field }), {}),
    };
    if (dateFieldNames.length)
        (0, graphql_1.registerEnumType)(fieldNameMap, { name: `${prefix}TimeFields` });
    let AggregateByTimeArgs = class AggregateByTimeArgs {
        constructor() {
            this.interval = defaultAggregateByTimeInterval;
        }
    };
    tslib_1.__decorate([
        (0, class_transformer_1.Type)(() => F),
        (0, class_validator_1.ValidateNested)(),
        (0, graphql_1.Field)(() => F, { nullable: true, description: 'Filter to find records to aggregate on' }),
        tslib_1.__metadata("design:type", Object)
    ], AggregateByTimeArgs.prototype, "filter", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Number, { nullable: true, description: 'Limit the number of results group by aggregation can return' }),
        tslib_1.__metadata("design:type", Number)
    ], AggregateByTimeArgs.prototype, "groupByLimit", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => (dateFieldNames.length ? fieldNameMap : InvalidFields), {
            nullable: false,
            description: 'Time field to aggregate by',
        }),
        (0, class_validator_1.IsIn)(dateFieldNames),
        tslib_1.__metadata("design:type", String)
    ], AggregateByTimeArgs.prototype, "field", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true, description: 'Should accumulate data' }),
        tslib_1.__metadata("design:type", Boolean)
    ], AggregateByTimeArgs.prototype, "accumulate", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Date, { nullable: false, description: 'Start date for aggregation by time' }),
        tslib_1.__metadata("design:type", Date)
    ], AggregateByTimeArgs.prototype, "from", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Date, { nullable: true, description: 'End date for aggregation by time (default now)' }),
        tslib_1.__metadata("design:type", Date)
    ], AggregateByTimeArgs.prototype, "to", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => aggregate_by_time_interval_1.AggregateByTimeInterval, { nullable: true, description: 'Aggregation intervals (default 1 day)' }),
        tslib_1.__metadata("design:type", aggregate_by_time_interval_1.AggregateByTimeInterval)
    ], AggregateByTimeArgs.prototype, "interval", void 0);
    AggregateByTimeArgs = tslib_1.__decorate([
        (0, graphql_1.ArgsType)()
    ], AggregateByTimeArgs);
    return AggregateByTimeArgs;
}
//# sourceMappingURL=aggregate-by-time-args.type.js.map