"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOrCreateDateFieldComparison = getOrCreateDateFieldComparison;
const tslib_1 = require("tslib");
const graphql_1 = require("@nestjs/graphql");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const validators_1 = require("../../validators");
const relative_date_scalar_type_1 = require("../../relative-date-scalar.type");
const date_field_comparison_between_1 = require("./date-field-comparison.between");
/** @internal */
let dateFieldComparison;
/** @internal */
function getOrCreateDateFieldComparison() {
    if (dateFieldComparison) {
        return dateFieldComparison;
    }
    let DateFieldComparison = class DateFieldComparison {
    };
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true }),
        (0, class_validator_1.IsBoolean)(),
        (0, class_validator_1.IsOptional)(),
        tslib_1.__metadata("design:type", Boolean)
    ], DateFieldComparison.prototype, "is", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true }),
        (0, class_validator_1.IsBoolean)(),
        (0, class_validator_1.IsOptional)(),
        tslib_1.__metadata("design:type", Boolean)
    ], DateFieldComparison.prototype, "isNot", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_scalar_type_1.RelativeDateScalar, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldComparison.prototype, "eq", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_scalar_type_1.RelativeDateScalar, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldComparison.prototype, "neq", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_scalar_type_1.RelativeDateScalar, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldComparison.prototype, "gt", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_scalar_type_1.RelativeDateScalar, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldComparison.prototype, "gte", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_scalar_type_1.RelativeDateScalar, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldComparison.prototype, "lt", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_scalar_type_1.RelativeDateScalar, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldComparison.prototype, "lte", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => [relative_date_scalar_type_1.RelativeDateScalar], { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Array)
    ], DateFieldComparison.prototype, "in", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => [relative_date_scalar_type_1.RelativeDateScalar], { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Array)
    ], DateFieldComparison.prototype, "notIn", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => date_field_comparison_between_1.DateFieldComparisonBetween, { nullable: true }),
        (0, class_validator_1.ValidateNested)(),
        (0, class_transformer_1.Type)(() => date_field_comparison_between_1.DateFieldComparisonBetween),
        tslib_1.__metadata("design:type", date_field_comparison_between_1.DateFieldComparisonBetween)
    ], DateFieldComparison.prototype, "between", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => date_field_comparison_between_1.DateFieldComparisonBetween, { nullable: true }),
        (0, class_validator_1.ValidateNested)(),
        (0, class_transformer_1.Type)(() => date_field_comparison_between_1.DateFieldComparisonBetween),
        tslib_1.__metadata("design:type", date_field_comparison_between_1.DateFieldComparisonBetween)
    ], DateFieldComparison.prototype, "notBetween", void 0);
    DateFieldComparison = tslib_1.__decorate([
        (0, graphql_1.InputType)('DateFieldComparison')
    ], DateFieldComparison);
    dateFieldComparison = DateFieldComparison;
    return dateFieldComparison;
}
//# sourceMappingURL=date-field-comparison.type.js.map