"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOrCreateDateFieldFutureComparison = getOrCreateDateFieldFutureComparison;
const tslib_1 = require("tslib");
const graphql_1 = require("@nestjs/graphql");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const validators_1 = require("../../validators");
const relative_date_future_scalar_type_1 = require("../../relative-date-future-scalar.type");
const date_field_comparison_between_1 = require("./date-field-comparison.between");
/** @internal */
let dateFieldComparison;
/** @internal */
function getOrCreateDateFieldFutureComparison() {
    if (dateFieldComparison) {
        return dateFieldComparison;
    }
    let DateFieldFutureComparison = class DateFieldFutureComparison {
    };
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true }),
        (0, class_validator_1.IsBoolean)(),
        (0, class_validator_1.IsOptional)(),
        tslib_1.__metadata("design:type", Boolean)
    ], DateFieldFutureComparison.prototype, "is", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true }),
        (0, class_validator_1.IsBoolean)(),
        (0, class_validator_1.IsOptional)(),
        tslib_1.__metadata("design:type", Boolean)
    ], DateFieldFutureComparison.prototype, "isNot", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_future_scalar_type_1.RelativeDateScalarFuture, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldFutureComparison.prototype, "eq", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_future_scalar_type_1.RelativeDateScalarFuture, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldFutureComparison.prototype, "neq", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_future_scalar_type_1.RelativeDateScalarFuture, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldFutureComparison.prototype, "gt", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_future_scalar_type_1.RelativeDateScalarFuture, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldFutureComparison.prototype, "gte", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_future_scalar_type_1.RelativeDateScalarFuture, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldFutureComparison.prototype, "lt", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => relative_date_future_scalar_type_1.RelativeDateScalarFuture, { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Date)
    ], DateFieldFutureComparison.prototype, "lte", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => [relative_date_future_scalar_type_1.RelativeDateScalarFuture], { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Array)
    ], DateFieldFutureComparison.prototype, "in", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => [relative_date_future_scalar_type_1.RelativeDateScalarFuture], { nullable: true }),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", Array)
    ], DateFieldFutureComparison.prototype, "notIn", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => date_field_comparison_between_1.DateFieldComparisonBetween, { nullable: true }),
        (0, class_validator_1.ValidateNested)(),
        (0, class_transformer_1.Type)(() => date_field_comparison_between_1.DateFieldComparisonBetween),
        tslib_1.__metadata("design:type", date_field_comparison_between_1.DateFieldComparisonBetween)
    ], DateFieldFutureComparison.prototype, "between", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => date_field_comparison_between_1.DateFieldComparisonBetween, { nullable: true }),
        (0, class_validator_1.ValidateNested)(),
        (0, class_transformer_1.Type)(() => date_field_comparison_between_1.DateFieldComparisonBetween),
        tslib_1.__metadata("design:type", date_field_comparison_between_1.DateFieldComparisonBetween)
    ], DateFieldFutureComparison.prototype, "notBetween", void 0);
    DateFieldFutureComparison = tslib_1.__decorate([
        (0, graphql_1.InputType)('DateFieldFutureComparison')
    ], DateFieldFutureComparison);
    dateFieldComparison = DateFieldFutureComparison;
    return dateFieldComparison;
}
//# sourceMappingURL=date-field-future-comparison.type.js.map