"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOrCreateJSONFieldComparison = getOrCreateJSONFieldComparison;
const tslib_1 = require("tslib");
const graphql_1 = require("@nestjs/graphql");
const class_validator_1 = require("class-validator");
const validators_1 = require("../../validators");
/** @internal */
let jsonFieldComparison;
/** @internal */
function getOrCreateJSONFieldComparison() {
    if (jsonFieldComparison) {
        return jsonFieldComparison;
    }
    let JsonFieldComparison = class JsonFieldComparison {
    };
    tslib_1.__decorate([
        (0, graphql_1.Field)({ nullable: true }),
        (0, class_validator_1.IsString)(),
        (0, validators_1.IsUndefined)(),
        tslib_1.__metadata("design:type", String)
    ], JsonFieldComparison.prototype, "containsLike", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true }),
        (0, class_validator_1.IsBoolean)(),
        (0, class_validator_1.IsOptional)(),
        tslib_1.__metadata("design:type", Boolean)
    ], JsonFieldComparison.prototype, "is", void 0);
    tslib_1.__decorate([
        (0, graphql_1.Field)(() => Boolean, { nullable: true }),
        (0, class_validator_1.IsBoolean)(),
        (0, class_validator_1.IsOptional)(),
        tslib_1.__metadata("design:type", Boolean)
    ], JsonFieldComparison.prototype, "isNot", void 0);
    JsonFieldComparison = tslib_1.__decorate([
        (0, graphql_1.InputType)('JsonFieldComparison')
    ], JsonFieldComparison);
    jsonFieldComparison = JsonFieldComparison;
    return jsonFieldComparison;
}
//# sourceMappingURL=json-field-comparison.type.js.map