export declare enum RelativeDateResolution {
    minutes = "minutes",
    hours = "hours",
    days = "days",
    weeks = "weeks",
    months = "months",
    years = "years"
}
export declare const RelativeDatePrefix = "last";
export declare const RelativeDateFuturePrefix = "next";
export type RelativeDatePrefixType = typeof RelativeDatePrefix;
export type RelativeDateFuturePrefixType = RelativeDatePrefixType | typeof RelativeDateFuturePrefix;
export type RelativeDate = `${RelativeDatePrefixType}-${number}-${RelativeDateResolution}`;
export type RelativeDateFuture = `${RelativeDateFuturePrefixType}-${number}-${RelativeDateResolution}`;
export type RelativeDateOrAbsoluteDate = number | string | RelativeDate;
export type RelativeDateFutureOrAbsoluteDate = number | string | RelativeDateFuture;
export declare const isRelativeDateScalar: (value: string) => value is RelativeDate;
export declare const isRelativeDateFutureScalar: (value: string) => value is RelativeDateFuture;
export declare const ACCEPTED_RELATIVE_DATE_VALUE = "an Epoch time (number), ISO Date string or a relative date value in the form of \"last-[N]-[minutes | hours | days | weeks | months | years]\"";
export declare const ACCEPTED_RELATIVE_DATE_FUTURE_VALUE = "an Epoch time (number), ISO Date string or a relative date value in the form of \"[last | next]-[N]-[minutes | hours | days | weeks | months | years]\"";
export declare const INVALID_RELATIVE_DATE_FORMAT_ERROR: (future?: boolean) => never;
export declare const isIsoDate: (str: string) => boolean;
export declare const parseRelativeDateFormat: (value: RelativeDate) => {
    resolution: RelativeDateResolution;
    span: number;
    isFuture: boolean;
};
export declare const parseRelativeDateFutureFormat: (value: RelativeDateFuture) => {
    resolution: RelativeDateResolution;
    span: number;
    isFuture: boolean;
};
