import { Class, DeepPartial, Filter } from '@rezonate/nestjs-query-core';
export interface UpdateManyInputType<DTO> {
    filter: Filter<DTO>;
    update: DeepPartial<DTO>;
}
/**
 * Input abstract type for all update many endpoints.
 * @param DTOClass - The DTO used to create a FilterType for the update.
 * @param UpdateType - The InputType to use for the update field.
 */
export declare function UpdateManyInputType<DTO>(DTOClass: Class<DTO>, UpdateType: Class<DeepPartial<DTO>>): Class<UpdateManyInputType<DTO>>;
