import { Class, DeepPartial } from '@rezonate/nestjs-query-core';
export interface UpdateOneInputType<DTO> {
    id: string | number;
    update: DeepPartial<DTO>;
}
/**
 * The abstract input type for update one endpoints.
 * @param DTOClass - The base DTO class the UpdateType is based on.
 * @param UpdateType - The InputType to use for the update field.
 */
export declare function UpdateOneInputType<DTO>(DTOClass: Class<DTO>, UpdateType: Class<DeepPartial<DTO>>): Class<UpdateOneInputType<DTO>>;
